<?php
defined('IN_CMS') or exit('No permission resources.');
pc_base::load_app_class('admin', 'admin', 0);
pc_base::load_sys_class('format', '', 0);
pc_base::load_sys_class('form', '', 0);
pc_base::load_sys_class('model', '', 0);

class push extends admin {
	function __construct() {
		$this->db = pc_base::load_model('push_model');
		$this->db_push_config = pc_base::load_model('push_config_model');
		$this->sitemodel_db = pc_base::load_model('sitemodel_model');
		$this->content_db = pc_base::load_model('content_model');
		$this->siteid = $this->get_siteid();
	}
	
	//百度推送
	public function init() {
		if(isset($_POST['dosubmit'])) {
			$ids=$_POST['ids'];
			if (empty($ids)) {
				showmessage(L('least_content'));
			} else {
				$url = $this->apiurl();
				if (empty($url)) {
					showmessage(L('push_config_url'), '?m=push&c=push&a=config&menuid='.$_GET['menuid']);
				}
				$modelid = $_GET['modelid'] = intval($_GET['modelid']);
				if(!$modelid) $modelid = 1;
				$this->content_db->set_model($modelid);
				if($this->content_db->table_name==$this->content_db->db_tablepre) showmessage(L('model_table_not_exists'));
				$data = array();
				$ids = implode(',', $ids);
				foreach($_POST['ids'] as $id) {
					$push_r = $this->db->get_one(array('modelid'=>$modelid,'contentid'=>$id));
					if ($push_r) {
						$ids = str_replace(','.$id,'',$ids);
						//showmessage(L('have_to_push'), HTTP_REFERER);
					}
				}
				//print_r($ids);
				$where = 'id in(' . $ids . ')';
				$rs = $this->content_db->select($where);
				if ($rs) {
					foreach ($rs as $key => $val) {
						$data[$key] = $val['url'];
					}
					$data = implode('\\n', $data);
					$result = $this->post($url, $data);
					$arr = json_decode($result, true);
					if (isset($arr['success'])) {
						if ($arr['success'] != '0') {
							foreach($_POST['ids'] as $id) {
								$this->db->insert(array('modelid'=>$modelid,'contentid'=>$id));
							}
							showmessage(L('push_success'), HTTP_REFERER);
						} else {
							showmessage(L('push_error').$result, HTTP_REFERER);
						}
					} else {
						showmessage(L('push_error').$result['message'], HTTP_REFERER);
					}
				}
			}
		}else{
			if(!$this->siteid) $this->siteid = 1;
			$rs = $this->db_push_config->get_one(array('siteid'=>$this->siteid));
			if(!$rs['id']) {
				showmessage(L('push_config_url'), '?m=push&c=push&a=config&menuid='.$_GET['menuid']);
			}
			$datas2 = $this->sitemodel_db->listinfo(array('siteid'=>$this->siteid,'type'=>0,'disabled'=>0),'','');
			$modelid = $_GET['modelid'] = intval($_GET['modelid']);
			if(!$modelid) $modelid = 1;
			$this->content_db->set_model($modelid);
			if($this->content_db->table_name==$this->content_db->db_tablepre) showmessage(L('model_table_not_exists'));
			$where = 'status=99';
			$pagesize = $_GET['pagesize'] ? $_GET['pagesize'] : 20;
			$datas = $this->content_db->listinfo($where,'id desc',$_GET['page'],$pagesize);
			$pages = $this->content_db->pages;
			include $this->admin_tpl('index');
		}
	}
	
	//参数配置
	public function config() {
		if(isset($_POST['dosubmit'])) {
			$url = $_POST['url'];
			$isauthor = $_POST['isauthor'];
			$r = $this->db_push_config->get_one(array('siteid'=>$_POST['siteid']));
			if(!$r['siteid']) {
				$this->db_push_config->insert(array('siteid'=>$this->siteid,'url'=>$url,'isauthor'=>$isauthor));
			} else {
				$this->db_push_config->update(array('siteid'=>$this->siteid,'url'=>$url,'isauthor'=>$isauthor),array('siteid'=>$r['siteid']));
			}
			showmessage(L('save_success'), '?m=push&c=push&a=init&menuid='.$_GET['menuid']);
		}else{
			if(!$this->siteid) $this->siteid = 1;
			$r = $this->db_push_config->get_one(array('siteid'=>$this->siteid));
			include $this->admin_tpl('config');
		}
	}
	
	//推送
	public function push() {
		$id = $_GET['id'];
		$url = $this->apiurl();
		if (empty($url)) {
			showmessage(L('push_config_url'), '?m=push&c=push&a=config&menuid='.$_GET['menuid']);
		}
		$modelid = $_GET['modelid'] = intval($_GET['modelid']);
		if(!$modelid) $modelid = 1;
		$this->content_db->set_model($modelid);
		if($this->content_db->table_name==$this->content_db->db_tablepre) showmessage(L('model_table_not_exists'));
		$rs = $this->content_db->get_one(array('id'=>$id));
		$push_r = $this->db->get_one(array('modelid'=>$modelid,'contentid'=>$rs['id']));
		if ($push_r) {
			showmessage(L('have_to_push'), HTTP_REFERER);
		}
		if ($rs) {
			$data = $rs['url'];
			$result = $this->post($url, $data);
			$arr = json_decode($result, true);
			if (isset($arr['success'])) {
				if ($arr['success'] != '0') {
					$this->db->insert(array('modelid'=>$modelid,'contentid'=>$id));
					showmessage(L('push_success'), HTTP_REFERER);
				} else {
					showmessage(L('push_error').$result, HTTP_REFERER);
				}
			} else {
				showmessage(L('push_error').$result['message'], HTTP_REFERER);
			}
		} else {
			showmessage(L('parameter_error'), HTTP_REFERER);
		}
		
	}
	
	public function apiurl() {
		if(!$this->siteid) $this->siteid = 1;
		$rs = $this->db_push_config->get_one(array('siteid'=>$this->siteid));
		if ($rs) {
			$url = $rs['url'];
			if ($rs['isauthor'] == 2) {
				$url = $url . '&type=original';
			}
			return $url;
		}
		return '';
	}
	
	public static function post($url,$data,$timeout=30,$head='') {
		$head=($head='')?FALSE:$head;
		$ch=curl_init();
		#设置超时
		curl_setopt($ch,CURLOPT_TIMEOUT,$timeout);
		#Url
		curl_setopt($ch,CURLOPT_URL,$url);
		curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,FALSE);
		curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,FALSE);
		#设置header
		curl_setopt($ch,CURLOPT_HEADER,$head);
		#要求结果为字符串且输出到屏幕上
		curl_setopt($ch,CURLOPT_RETURNTRANSFER,TRUE);
		#post提交方式
		curl_setopt($ch,CURLOPT_POST,TRUE);
		curl_setopt($ch,CURLOPT_POSTFIELDS,$data);
		$result=curl_exec($ch);
		curl_close($ch);
		return $result;
	}
}
?>